package client;

import java.awt.Image;
import java.awt.Graphics;
import java.awt.Toolkit;
import java.awt.Graphics2D;

class BitmapSprite {
  
  protected double locx;
  protected double locy;
  private int width,height;
  protected Image image;                   
  private GestionnaireFenetre fenetre;

  protected double angle = 0;
  protected double dernierX = 0;
  protected double dernierY = 0;
  
/////////////////////////////////////////////////////////////////
// Constructeur alternatif
/////////////////////////////////////////////////////////////////
  
  public BitmapSprite(double x,double y,String id,GestionnaireFenetre fen) {
    locx = x;
    locy = y;
	//charge l'image
    image = Toolkit.getDefaultToolkit().getImage("sprites/"+id); 
    fenetre = fen;
  }
     	
/////////////////////////////////////////////////////////////////
// Mthodes d'affichage et de rglage
/////////////////////////////////////////////////////////////////
  
  public double getX(){return locx;}
  public double getY(){return locy;}
  public int getLargeur(){return image.getWidth(fenetre);}
  public int getHauteur(){return image.getHeight(fenetre);}  

  public void update(Graphics g) {
	paint(g);
  }

  // Fonction de base
  public void paint(Graphics g) {
    	g.drawImage(image,(int)locx,(int)locy,fenetre);
  }

  // Pour les individus  
  public void paint2D(Graphics2D g) {

		// C'est ici qu'on gre la rotation
    	double centreX = locx + image.getWidth(fenetre)/2;
    	double centreY = locy + image.getHeight(fenetre)/2;

		double dx = locx - dernierX;
		double dy = locy - dernierY;

		if (dx == 0){}
		else if (dx < 0){angle = Math.atan(dy/dx) - Math.PI/2;}
		else if (dx > 0){angle = Math.atan(dy/dx) + Math.PI/2;}

    	g.rotate(angle, centreX, centreY);
    	g.drawImage(image,(int)locx,(int)locy,fenetre);
    	g.rotate(-angle, centreX, centreY);

  }
}

