package client;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.net.MalformedURLException;
import java.rmi.NotBoundException;
import java.awt.Font;
import java.awt.Event;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.InputEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JOptionPane;
import javax.swing.JFrame;
import javax.swing.JDialog;
import serveur.Serveur;
import serveur.VecteurSerie;
import serveur.FenetreEntree;

public class Client extends Thread {
   
  // variables ncessaire  l'tablissement du protocole client/serveur
  static private String nomOrdi;
  static public Serveur serv;
  public boolean fonctionne=true;

  private int numero;

    static private String nomJoueur;
    private boolean actif;
    private int identite;    
    boolean seulementClient; // true si seul un client a t cr par FenetreEntree
    public boolean serveurTrouve=false;

    FenetreEntree pere;

  // variables de stockage de donnes
	public VecteurSerie listeTerrain = new VecteurSerie();
  	public VecteurSerie listeIndividus = new VecteurSerie();
    private int nombreIndividus = 0;

  // taille du terrain de jeu complet;
    public int HORIZ_TOTAL ; //2000;
    public int VERT_TOTAL ; //2000;
  
  // taille de la fentre  l'cran
    private int MAX_HORIZ = 900; //1000;
    private int MAX_VERT = 600; //1000;

  // parametres de jeu
  private int score;                 // nombre de mouton sauvs
  private boolean gameOver;          // comme le nom l'indique

  // Gestionnaires de fentrage, d'affichage, d'animation et d'interaction
  private GestionnaireFenetre gestfen;
  private GestionnaireImages gestim;                        
  private GestionnaireTerrain gestter;       
  private GestionnaireEntreesSorties gestes;       

  // de quoi crire
  static private Font bigfont = new Font("TimesRoman", Font.BOLD,24);
  static private Font medfont = new Font("TimesRoman", Font.PLAIN,18);
  static private Font smallfont = new Font("TimesRoman", Font.PLAIN,12);
    JFrame icone;	

/////////////////////////////////////////////////////////////////
// mthodes d'initialisation du protocole client/serveur
/////////////////////////////////////////////////////////////////
  
    //nomme le serveur
    public void setNomOrdi (String nom) {
	nomOrdi=nom;
    }
    
    public String getNomOrdi(){
    	return nomOrdi;
    }
    
    //nomme le joueur
    public void setNomJoueur (String nom) {
	nomJoueur=nom;
    }
    
    public String getNomJoueur(){
    	return nomJoueur;
    }

    public int getNumeroJoueur(){
    	return (numero);
    }

    //pour savoir qui est le serveur
    public Serveur getServeur(){return serv;}
	
    //Trouve le nom du serveur
    void trouveServeur() {
	try {
	    serv = (Serveur) Naming.lookup("//"+nomOrdi+":8090/ServeurService");
	    serveurTrouve=true;
	}
	catch (MalformedURLException murle) {
	    JOptionPane.showMessageDialog(icone,"Ce serveur est actuellement inaccessible. Essayez-en un autre !",
			      "Alerte !",
			      JOptionPane.WARNING_MESSAGE);
	    pere.show();
	    serveurTrouve=false;
        }
        catch (RemoteException re) {
	    JOptionPane.showMessageDialog(icone,"Ce serveur est actuellement inaccessible. Essayez-en un autre !",
			      "Alerte !",
			      JOptionPane.WARNING_MESSAGE);
	    pere.show();
	    serveurTrouve=false;
        }
        catch (NotBoundException nbe) {
	    JOptionPane.showMessageDialog(icone,"Ce serveur est actuellement inaccessible. Essayez-en un autre !",
					  "Alerte !",
					  JOptionPane.WARNING_MESSAGE);
	    pere.show();
	    serveurTrouve=false;
        }
    }

    //Prvient le serveur de l'arrive d'un nouveau client
    public void declareClient () {
	//0 : tat neutre de dbut de partie
	try {
	    numero=serv.nouveauClient(getNomJoueur(), 0);
	}
        catch (Exception re) {}

    }
   
    //Recupre le terrain et les positions des individus depuis le serveur
    public void recupereInit (VecteurSerie terrain, VecteurSerie individus) {
    	// On est oblige de faire des copies element par element dans cette fonction
    	// car clone ne marche pas.
		int i,j;
		VecteurSerie temp;
	
	try{

	    temp=serv.donneTerrain();
	    for (i=0;i<temp.size();i++)
		    terrain.addElement(temp.get(i));
		
		temp=serv.donneSituation();
		nombreIndividus = temp.size();
		
		for (j=0;j<temp.size();j++)
		    individus.addElement((Data)(temp.get(j)));
		
	}    
    catch(RemoteException re){System.err.println(re);}
        
  }
  
   //raccourci d'initialisation globale
    public void initClient (VecteurSerie terrain, VecteurSerie individus){
		trouveServeur();
		if (serveurTrouve) {
		    declareClient();
		    try {
			HORIZ_TOTAL=serv.donneTailleCarteHoriz();}	   
		    catch (RemoteException re) {}
		    try {
			VERT_TOTAL=serv.donneTailleCarteVert();}
		    catch (RemoteException re) {}
		    recupereInit(terrain, individus);
	}
    }
    
    //terminaison du client
    public void stoppeClient () {
		fonctionne=false;
	
		try {	serv.finClient(numero);}
		catch (RemoteException re) {}
		if (seulementClient==true) {
		    pere.fermeJeu();
		}
	}

    
/////////////////////////////////////////////////////////////////
// transmission des clics et touches d'un gestionnaire  l'autre
///////////////////////////////////////////////////////////////// 
 
  //Passer les infos d'un clic de souris au gestionnaire d'entres/sorties
  public boolean mouseDown(MouseEvent e) {

  	if (e.getButton()== MouseEvent.BUTTON3)
  	{
  	 gestfen.repositionneClic(e.getX(),e.getY());
  	}
  	else 
  		if (e.isShiftDown())
 		{
 		 if (e.getButton()== MouseEvent.BUTTON1) {gestes.mouseShiftDown(e.getX(),e.getY());}
 		}
  		else 
  			if (e.getButton()== MouseEvent.BUTTON1) {gestes.mouseDown(e.getX(),e.getY());}
    return true;
  	}	
  
  // passer les touches claviers au gestionnaires d'entres/sorties
  public boolean keyDown(KeyEvent e) {
    gestes.keyDown(e);
    return true;
  }   

/////////////////////////////////////////////////////////////////
// transmission de donnes  la demande
///////////////////////////////////////////////////////////////// 
  public int donnePosXIndiv(int qui){
  	return (int) ((Data)(listeIndividus.elementAt(qui))).getPosx();
  }
  
  public int donnePosYIndiv(int qui){
  	return (int) ((Data)(listeIndividus.elementAt(qui))).getPosy();
  }
    
  public VecteurSerie donneScore(){
  	VecteurSerie scores= new VecteurSerie();
  	try{ scores = serv.donneScore();}
	    catch (RemoteException re){};
	return (scores);
  }  
  
/////////////////////////////////////////////////////////////////
// mise  jour des donnes et de l'affichage
/////////////////////////////////////////////////////////////////   
    
    public void metAJour () {
	if (fonctionne) {
	    try{
		listeIndividus = serv.donneSituation();
		// Si il faut recharger les images
		if(serv.recupereIdClient(numero).ilFautMettreAJour()){
			gestim.modifsNom(listeIndividus);
			serv.majEffectuee(numero);
		}
		// Si il faut tout remettre a jour
		if(nombreIndividus != listeIndividus.size()){
		    remiseAJourGestionnaires();
		    nombreIndividus = listeIndividus.size();
			serv.majEffectuee(numero);
		}
		// Deplace les individus, toujours effectue
		gestim.metAJour(listeIndividus);
	    }
	    catch (RemoteException re) {
		fonctionne=false;
		new FenetreErreurReseau(this);
	    }
	}
    }
  
/////////////////////////////////////////////////////////////////
// remise  jour des gestionnaires
/////////////////////////////////////////////////////////////////


    public void remiseAJourGestionnaires(){
		gestim.remiseAJour(listeIndividus);
		gestes.remiseAJour(listeIndividus);
    }

/////////////////////////////////////////////////////////////////
// lancement du client
/////////////////////////////////////////////////////////////////
  public void main(String nomServ, String nomCli, boolean solo, String ambiance, FenetreEntree papa) {
    
      //initialisation client
      setNomJoueur(nomCli);
      setNomOrdi(nomServ);
      seulementClient=solo;
      pere=papa;
      initClient(listeTerrain,listeIndividus);
      
      if (serveurTrouve) {
      //lancement de l'affichage et des animations
      actif=true;
      
      // initialisation des gestionnaires

      gestfen = new GestionnaireFenetre(MAX_HORIZ,MAX_VERT,this);
      gestim = new GestionnaireImages(MAX_HORIZ,MAX_VERT,listeIndividus, ambiance, gestfen,this);              
      gestter = new GestionnaireTerrain(MAX_HORIZ,MAX_VERT,listeTerrain, ambiance, gestfen,this); 
      gestes = new GestionnaireEntreesSorties(MAX_HORIZ,MAX_VERT,listeIndividus,gestfen,this);     

      // Lance l'affichage
      gestfen.lancer();
      }
 }

}


