/////////////////////////////////////////////////////////////////
// structure de donnes pour le transfert d'info serveur/client
// et autres oprations de mmorisation de donnes
/////////////////////////////////////////////////////////////////
package client;

import java.io.Serializable;

public class Data implements Serializable, Cloneable {
	
	private String nom;
	private String aqui;
	private double posx;
	private double posy;
	private int identite;

/////////////////////////////////////////////////////////////////
// Interface avec l'extrieur
/////////////////////////////////////////////////////////////////
	public String getNom() {return nom; }
	public double getPosx(){return posx;}
	public double getPosy(){return posy;}
	public String getPossesseur(){return aqui;}
	public int getIdentite(){return identite;}

/////////////////////////////////////////////////////////////////
// nouveau constructeur de Data pour les scores
/////////////////////////////////////////////////////////////////

	public Data(String qui, int score){
		nom = qui;
		posx=0;posy=0;aqui="";
		identite=score;
	}
	
/////////////////////////////////////////////////////////////////
// nouveau constructeur de Data pour les chemins
/////////////////////////////////////////////////////////////////

	public Data(double x, double y){
		nom = "";
		posx = x;
		posy = y;
		aqui = "";
		identite=0;
	}
	
/////////////////////////////////////////////////////////////////
// ancien constructeur de Data pour les chemins
/////////////////////////////////////////////////////////////////

	public Data(double x, double y, int ident){
		nom = "";
		posx = x;
		posy = y;
		aqui = "";
		identite=ident;
	}
	
/////////////////////////////////////////////////////////////////
// nouveau constructeur de Data (pour les chiens et les loups)
/////////////////////////////////////////////////////////////////

	public Data(String n, double x, double y, String poss){
		nom = n;
		posx = x;
		posy = y;
		aqui = poss;
		identite=0;  
	}

	
/////////////////////////////////////////////////////////////////
// ancien constructeur de Data (pour les moutons)
/////////////////////////////////////////////////////////////////
	
	public Data(String n, double x, double y){
		nom = n;
		posx = x;
		posy = y;
		aqui = "";
		identite=0;
	}

/////////////////////////////////////////////////////////////////
// ancien constructeur alternatif de Data (pour le terrain)
/////////////////////////////////////////////////////////////////
	
	public Data(String n){
		nom = n;
		posx = 0;
		posy = 0;
		aqui = "";
		identite=0;
	}

}
