package client;
import java.awt.*; 
import java.awt.event.*;
import javax.swing.*;
import java.net.URL;
import java.io.IOException;

import serveur.PanelImage;



/***********************************************************************
 * Fentre qui s'affiche lorsque l'utilisateur presse "H", et qui dcrit 
 * le jeu et ses commandes.
 ***********************************************************************/
public class EcranAide extends JFrame {
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    JTextPane aideTexte= new JTextPane();

    JButton boutonQuitter=new JButton("Quitter");

    Client pere;

    private Image titre;
    private String nomImage;
    private PanelImage icone;

    class ActionQuitter implements ActionListener {
        public synchronized void actionPerformed(ActionEvent e) 
        {dispose();}
    };

    
    public EcranAide (Client papa) {
	super ("CroqueMouton 1.0"); 
	pere=papa;
	
	Dimension tailleEcran = Toolkit.getDefaultToolkit().getScreenSize();

	getContentPane().setLayout(gridbag);
	c.fill = GridBagConstraints.BOTH;

	nomImage="sprites/titre.gif";
	titre = Toolkit.getDefaultToolkit().createImage(nomImage);
	
	icone = new PanelImage(titre); 

	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(icone,c);
	getContentPane().add (icone);
	icone.setSize(525,100);

	creeAideTexte();
	
	JScrollPane texteScroll = new JScrollPane(aideTexte);
        texteScroll.setVerticalScrollBarPolicy( JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	texteScroll.setPreferredSize(new Dimension(250, 500));
        texteScroll.setMinimumSize(new Dimension(10, 10));
	
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(texteScroll,c);
	getContentPane().add (texteScroll);

	aideTexte.setEditable(false);
	


	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(boutonQuitter,c);
	getContentPane().add (boutonQuitter);
	boutonQuitter.addActionListener(new ActionQuitter());
	pack(); 
	setVisible(true);

    }



    //Va chercher le fichier  afficher, et lance son affichage
    private void creeAideTexte() {
	String s = null;
        try {
            s = "file:"
		+ System.getProperty("user.dir")
		+ System.getProperty("file.separator")
                + "aide.html";
            URL aideURL = new URL(s);
            afficheURL(aideURL, aideTexte);
        } catch (Exception e) {
            System.err.println("N'a pas pu trouver l'aide " + s);
        }
	
	
    }

    //Rcuprer le fichier  afficher, et l'afficher
    private void afficheURL(URL url, JEditorPane editeur) {
        try {
            editeur.setPage(url);
        } catch (IOException e) {
            System.err.println("Mauvaise URL : " + url);
        }
    }



}
