package client;

import java.rmi.RemoteException;
import java.awt.Event;
import java.awt.event.KeyEvent;
import serveur.VecteurSerie;
import client.EcranAide;

public class GestionnaireEntreesSorties {

  private int horiz, vert;
  private int actif;
  private int reposx,reposy;
  private VecteurSerie chemin;
  private boolean map, score;
  private VecteurSerie individus;
  private VecteurSerie acquisition; //ceux qu'on controle
  private Client pere;
  private GestionnaireFenetre fenetre;
  
    
/////////////////////////////////////////////////////////////////
// constructeur
/////////////////////////////////////////////////////////////////
  
  public GestionnaireEntreesSorties(int horizontal,int vertical,VecteurSerie indiv,
   								GestionnaireFenetre fen, Client cli) 
   	{
    horiz = horizontal;
    vert = vertical;
    individus = (VecteurSerie)(indiv);
    acquisition = new VecteurSerie();
    fenetre = fen;
    pere = cli;
    actif = 1;
    marquage();
    
	}
/////////////////////////////////////////////////////////////////
// remise  jour
/////////////////////////////////////////////////////////////////

    public void remiseAJour(VecteurSerie donn){
	individus.clear();
	acquisition.clear();
	individus = (VecteurSerie)donn;
	marquage();
	repositionne();  //centrer l'cran sur les chiens (si ils sont avant les loups dans le vecteur)
    }


/////////////////////////////////////////////////////////////////
// reprage des individus que le joueur contrle et prparation
// du ncessaire  points de route
/////////////////////////////////////////////////////////////////
  
  public void marquage(){
    int i;
    for (i=0;i<individus.size();i++)
    {
    	if (((String)(((Data)(individus.elementAt(i))).getPossesseur())).equals(pere.getNomJoueur()))
    	{
    	//les actifs potentiels
    	acquisition.add(new Possession(((Data)(individus.elementAt(i))).getNom(),
    									i, pere.getNomJoueur())); 
    	}
    }
    fenetre.prepareSelection(acquisition.size(),actif);
    fenetre.selectionne(((Possession)(acquisition.elementAt(actif-1))).getIdentite());
  }


/////////////////////////////////////////////////////////////////
// traitement des clics de souris
/////////////////////////////////////////////////////////////////
  public void mouseDown(int x, int y){
  	int pos = ((Possession)(acquisition.elementAt(actif-1))).getIdentite();
  	donneMouvement(pos, fenetre.convertiX(x), fenetre.convertiY(y));
  	
  }
  
  public void mouseShiftDown(int x, int y){
  	donnePointDeRoute(((Possession)(acquisition.elementAt(actif-1))).getIdentite(), fenetre.convertiX(x), fenetre.convertiY(y));
  	
  }
    
/////////////////////////////////////////////////////////////////
// traitement des touches clavier
/////////////////////////////////////////////////////////////////
  public void keyDown(KeyEvent e){
  	
  	if (e.getKeyChar()==KeyEvent.VK_PAGE_UP) {
  		actif = actif - 1;
  		if (actif<1) {actif=acquisition.size();}
		repositionne();
  	}
  	
  	if (e.getKeyChar()==KeyEvent.VK_PAGE_DOWN) {
  		actif = actif + 1;
  		if (actif>acquisition.size()) {actif=1;}
		repositionne();
  	}
  	
	if ((e.getKeyChar()==KeyEvent.VK_1)||(e.getKeyChar()==KeyEvent.VK_NUMPAD1)) {
		actif=1;
		if (actif>acquisition.size()) {actif=1;}
		repositionne();		
		}
	
	if ((e.getKeyChar()==KeyEvent.VK_2)||(e.getKeyChar()==KeyEvent.VK_NUMPAD2)){
		actif=2;
		if (actif>acquisition.size()) {actif=1;}
		repositionne();
		}
		
	if ((e.getKeyChar()==KeyEvent.VK_3)||(e.getKeyChar()==KeyEvent.VK_NUMPAD3)){
		actif=3;
		if (actif>acquisition.size()) {actif=1;}
		repositionne();
		}
		
	if ((e.getKeyChar()==KeyEvent.VK_4)||(e.getKeyChar()==KeyEvent.VK_NUMPAD4)){
		actif=4;
		if (actif>acquisition.size()) {actif=1;}
		repositionne();
		}
		
 	if ((e.getKeyChar()==KeyEvent.VK_5)||(e.getKeyChar()==KeyEvent.VK_NUMPAD5)){
		actif=5;
		if (actif>acquisition.size()) {actif=1;}
		repositionne();
		}
		
 	if ((e.getKeyChar()==KeyEvent.VK_6)||(e.getKeyChar()==KeyEvent.VK_NUMPAD6)){
		actif=6;
		if (actif>acquisition.size()) {actif=1;}
		repositionne();
		}
		
 	if ((e.getKeyChar()==KeyEvent.VK_7)||(e.getKeyChar()==KeyEvent.VK_NUMPAD7)){
		actif=7;
		if (actif>acquisition.size()) {actif=1;}
		repositionne();
		}
		
 	if ((e.getKeyChar()==KeyEvent.VK_8)||(e.getKeyChar()==KeyEvent.VK_NUMPAD8)){
		actif=8;
		if (actif>acquisition.size()) {actif=1;}
		repositionne();
		}
		
 	if ((e.getKeyChar()==KeyEvent.VK_9)||(e.getKeyChar()==KeyEvent.VK_NUMPAD9)){
		actif=9;
		if (actif>acquisition.size()) {actif=1;}
		repositionne();
		}
  
	if ((e.getKeyChar()=='s')||(e.getKeyChar()=='S')){
		actif=actif+1;
		if (actif>acquisition.size()) {actif=1;}
		repositionne();
	}
	if ((e.getKeyChar()=='x')||(e.getKeyChar()=='X')){
		actif=actif-1;
		if (actif<1) {actif=acquisition.size();}
		repositionne();
	}

  	fenetre.prepareSelection(acquisition.size(),actif);
  	fenetre.selectionne(((Possession)(acquisition.elementAt(actif-1))).getIdentite());

	if ((e.getKeyChar()=='h')||(e.getKeyChar()=='H')){
  		new EcranAide(pere);
   	}

	if ((e.getKeyChar()=='z')||(e.getKeyChar()=='Z')){
  		fenetre.modifieZoom(-1);
   	}

  	if ((e.getKeyChar()=='e')||(e.getKeyChar()=='E')) {
  		fenetre.modifieZoom(1);
  	}
			
	else {/* rien pour les autres touches */}
	
  }

/////////////////////////////////////////////////////////////////
// repositionne l'cran
/////////////////////////////////////////////////////////////////
  public void repositionne(){
  	reposx=pere.donnePosXIndiv((int)((Possession)(acquisition.elementAt(actif-1))).getIdentite());
	reposy=pere.donnePosYIndiv((int)((Possession)(acquisition.elementAt(actif-1))).getIdentite());
	fenetre.repositionneSelection(reposx, reposy);
  }

/////////////////////////////////////////////////////////////////
// envoie des donnes concernant les clics de souris
/////////////////////////////////////////////////////////////////
  public void donneMouvement(int qui, int cibleHoriz, int cibleVert ) {
	try{
	if (pere.getServeur().recupereMouvement(qui, cibleHoriz, cibleVert)!=0) {
	    System.err.println("Forbidden Movement");
		};
	}
        catch (RemoteException re) {
            System.err.println("RemoteException" + re);
        }
    }
    
    
  public void donnePointDeRoute(int qui, int cibleHoriz, int cibleVert) {
   	try{
	if (pere.getServeur().recuperePointDeRoute(qui, cibleHoriz, cibleVert)!=0) {
	    System.err.println("Forbidden Movement");
		};
	}
        catch (RemoteException re) {
            System.err.println("RemoteException" + re);
        }
    }
   
    
  
}
