package client;

import java.awt.image.BufferedImage; 
import java.awt.*; 

import java.awt.Font;
import java.awt.Graphics; 
import java.awt.Image;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.BorderLayout; 
import java.awt.Event; 
import java.awt.event.WindowListener; 
import java.awt.event.MouseListener;
import java.awt.event.MouseWheelListener;
import java.awt.event.MouseEvent;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseWheelEvent;
import java.awt.event.InputEvent;
import java.awt.event.WindowEvent; 
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JFrame;
import javax.swing.JDialog;
import java.rmi.RemoteException;
import java.lang.Thread;
import serveur.VecteurSerie;
import serveur.EcranFin;

class GestionnaireFenetre extends JFrame implements WindowListener, KeyListener, MouseListener, MouseWheelListener, Runnable{

  private JLabel legende=new JLabel("CroqueMouton 1.0");
  private int MAX_HORIZ, MAX_VERT;  // taille totale de l'image 
  private int HORIZTOT, VERTTOT;  // taille de l'image  l'cran
  static final int taillecase = 100; // cot d'une case -  calculer si on change a
  private int compteur, compteurtest = 0;
  private int decale = 10;
  
  // variables pour le double buffering, l'animation
  private Thread animation;
    private JFrame frame;
  private Graphics2D offscreen;
  private BufferedImage offimg;
  private boolean affichageEnCours = false;
  
  private Graphics2D ecranSelection;
  private BufferedImage imageSelection;
  
  private Graphics2D ecranScore;
  private BufferedImage imageScore;

  private Fantome fantometemp;
  static final int RAFFRAICHISSEMENT = 10;       // en ms
  public boolean marche;  

  // parametre pour le scrolling
  public int posxcourrante;	//private
  public int posycourrante;
  public int decalage = 100;
  public int reduction = 2;

  // vecteurs contenant les diffrents sprites  afficher
  private VecteurSerie terrain = new VecteurSerie();
  public VecteurSerie individus = new VecteurSerie();
  private Client pere;

  //identit de l'animal selectionn
  private int qui;

  //variable pour le dessin	du rectangle dans la minicarte
  private int hauteur;
  private int longueur;
  
  // fonts
  private String selection1 = "";
  private String selection2 = "";
  private String actif = "";
  private String moutonsRestants = "";
  private VecteurSerie scoresJoueurs;
  static private Font courierFont= new Font("Courier",Font.BOLD+Font.ITALIC,24);
  static private Font bigfont = new Font("TimesRoman", Font.BOLD,24);
  static private Font medfont = new Font("TimesRoman", Font.PLAIN,18);
  static private Font smallfont = new Font("TimesRoman", Font.PLAIN,12);
  
/////////////////////////////////////////////////////////////////
// constructeur
/////////////////////////////////////////////////////////////////

  public GestionnaireFenetre(int horiz,int vert, Client cli) {
    super ("CroqueMouton 1.0");
    marche=true;
    setVisible(false);
    MAX_HORIZ = horiz;
    MAX_VERT = vert;
    posxcourrante = 0;
    posycourrante = 0;
    pere = cli;
    HORIZTOT = pere.HORIZ_TOTAL;
    VERTTOT = pere.VERT_TOTAL;
    initAffichage();
    addWindowListener(this);  //pour la fermeture de fenetre
	addMouseListener(this);   //pour les clics souris
	addKeyListener(this);     //pour les touches claviers
	animation = new Thread(this);
    }

  public void lancer(){
      int j;
      VecteurSerie temp;
      try{
	  temp=pere.serv.donneSituation();
	  for (j=0;j<temp.size();j++) {
	      pere.listeIndividus.addElement(temp.get(j));}}
      catch (RemoteException re) {
	  pere.fonctionne=false;
	  new FenetreErreurReseau(pere);
	  temp=new VecteurSerie();
      }
      
      while (animation == null) {}
	  animation.start();
	       

  }
	
/////////////////////////////////////////////////////////////////
// construction et affichage du terrain
/////////////////////////////////////////////////////////////////
 
  	public void construitTerrain(Fantome panel){
		terrain.addElement(panel);
	}

  public void afficheTerrain(){
  	int caseX, caseY, hauteur, largeur;
  	for (compteur = 0; compteur<terrain.size(); compteur++){

		fantometemp = ((Fantome)terrain.elementAt(compteur));
		
			fantometemp.paint(offscreen);;
		
  	}
  	
  }
  
/////////////////////////////////////////////////////////////////
// construction, mise  jour et affichage des individus
/////////////////////////////////////////////////////////////////

  public void construitIndividus(Fantome indiv){
      individus.addElement(indiv);
    }

  public void metAJour(int id, double x, double y){
  	((Fantome)(individus.elementAt(id))).reglePosition(x,y);
  }
     	
  public void afficheIndividus(){
  	for (compteur = 0; compteur<individus.size(); compteur++){
		fantometemp = ((Fantome)(individus.elementAt(compteur)));		
  		fantometemp.paint2D(offscreen);
  		}
  	offscreen.setColor(Color.yellow);
  	offscreen.drawOval(pere.donnePosXIndiv(qui),pere.donnePosYIndiv(qui),75,75);
  }
  
/////////////////////////////////////////////////////////////////
// efface les individus
/////////////////////////////////////////////////////////////////
    public void effaceIndividus(){
	individus.clear();
    }

/////////////////////////////////////////////////////////////////
// initialise l'affichage
/////////////////////////////////////////////////////////////////
  
  public void initAffichage() {
  	
    setForeground(Color.red);
    setFont(smallfont);
    int tailleX=MAX_HORIZ+decalage;
    int tailleY=MAX_VERT+decalage;
    
    Dimension tailleEcran = Toolkit.getDefaultToolkit().getScreenSize();
    setLocation(tailleEcran.width-(tailleX),tailleEcran.height-(tailleY));

    offimg = new BufferedImage(HORIZTOT, VERTTOT, 1); // 5 : RGB 24 bits
    offscreen = offimg.createGraphics();
    	
    imageSelection = new BufferedImage(HORIZTOT,decalage,1);
    ecranSelection = imageSelection.createGraphics();
    
    imageScore = new BufferedImage(decalage,VERTTOT,1);
    ecranScore = imageScore.createGraphics();
    
   	setSize(tailleX, tailleY);

  }
  
/////////////////////////////////////////////////////////////////
// surcharge update pour ne pas craser l'cran
/////////////////////////////////////////////////////////////////
  
  public void update(Graphics g) {
	// C'est normal que ca soit vide
	// Ne pas effacer l'cran et plus d'image parasite !
      //      if (marche) paint(g);
  }
  
/////////////////////////////////////////////////////////////////
// surcharge de paint
/////////////////////////////////////////////////////////////////
  public void paint(Graphics g) {
  	
      if (marche) {
	  try {
	      if ((pere.serv.demandePartieFinie())==true) {
		  marche=false;
		  new EcranFin (pere.serv.finPartie(), pere);
	      }
	  }
	  catch (RemoteException re) {
	      marche=false;
	  }

	  if (affichageEnCours == false){
	      affichageEnCours = true;

	      pere.metAJour();					// met a jour les donnees du client

	      offscreen.clearRect(0,0,HORIZTOT,VERTTOT);
	      afficheTerrain();
	      afficheIndividus();					// affiche les individus dans le buffer		
	      ecranSelection.clearRect(0,0,HORIZTOT,decalage);
	      afficheSelection(ecranSelection); // affiche la selection dans un buffer
	      ecranScore.clearRect(0, decalage, decalage, VERTTOT);
	      afficheScore(ecranScore);  // affiche les scores dans un buffer

          MAX_HORIZ = this.getWidth()-decalage;
          MAX_VERT = this.getHeight()-decalage;
          
		  g.drawImage(offimg, decalage, decalage, MAX_HORIZ+decalage, MAX_VERT+decalage, posxcourrante, posycourrante, MAX_HORIZ*reduction+posxcourrante, MAX_VERT*reduction+posycourrante, Color.black, this);
	      g.drawImage(offimg, 0,20,decalage,decalage, 0, 0, HORIZTOT, VERTTOT, Color.black, this);
		  g.drawImage(imageSelection,decalage,20,HORIZTOT,decalage,decalage,20,HORIZTOT,decalage, Color.black, this);
		  g.drawImage(imageScore,0,decalage,decalage,VERTTOT,0,decalage,decalage,VERTTOT, Color.black, this);
		  
		  //test de rectangle sur minicarte
          g.setColor(Color.yellow);
          if (MAX_HORIZ*reduction>HORIZTOT) {longueur=decalage;} 
          else {longueur=reduction*MAX_HORIZ*decalage/HORIZTOT;}
          if (MAX_VERT*reduction>VERTTOT) {hauteur=(decalage-20);}
          else {hauteur= reduction*MAX_VERT*(decalage-20)/VERTTOT;}
          g.drawRect(decalage*posxcourrante/HORIZTOT,(decalage-20)*posycourrante/VERTTOT+20,longueur,hauteur);

  
	      affichageEnCours = false;
	  }
      }
  }

/////////////////////////////////////////////////////////////////
// moteur d'affichage
/////////////////////////////////////////////////////////////////
  public void run() {
  	  	 
	setVisible(true);
	
       try {
       } catch (Exception exc) { };
	

    while (marche) {
		// Affiche l'image offscreen  l'cran
    	this.paint(this.getGraphics());

       //attend durant le temps de raffraichissement avant tout nouvel affichage
       Thread.currentThread().yield();
       try {
       		Thread.currentThread().sleep (RAFFRAICHISSEMENT);
       } catch (Exception exc) { };

      }

  }
  
/////////////////////////////////////////////////////////////////
// mthodes de l'interface MouseListener
/////////////////////////////////////////////////////////////////
  public void mouseClicked(MouseEvent e) {
  	if ((e.getX()<decalage)&&(e.getY()<decalage+20))
  	{repositionneMiniCarte(e.getX(),e.getY());}
 	else {pere.mouseDown(e);}
  }
  
  public void mouseEntered(MouseEvent e) {
  }
 
  public void mouseExited(MouseEvent e) {
  }
  
  public void mousePressed(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
  
/////////////////////////////////////////////////////////////////
// mthodes de l'interface KeyListener
/////////////////////////////////////////////////////////////////
  
  public void keyPressed(KeyEvent e) {
	if (e.getKeyCode() == KeyEvent.VK_UP) {      
  		scrollhaut();
    	}
    else if (e.getKeyCode() == KeyEvent.VK_DOWN){
    	scrollbas();
    	}
    else if (e.getKeyCode() == KeyEvent.VK_RIGHT){
    	scrolldroite();
    	}
    else if (e.getKeyCode() == KeyEvent.VK_LEFT){
    	scrollgauche();
    	}  
	else {pere.keyDown(e);}
  }
  
  public void keyTyped(KeyEvent e) {
  }
  
  public void keyReleased(KeyEvent e) {
  }

/////////////////////////////////////////////////////////////////
// mthodes de l'interface MouseWheelListener 
// (ne sert pas pour l'instant)
/////////////////////////////////////////////////////////////////
  public void mouseWheelMoved(MouseWheelEvent e){
  	reduction = reduction - (e.getWheelRotation()/2);
  	if (reduction<1) {reduction=1;}    //petit indice = grand zoom (de prs)
  	if (reduction>5) {reduction=5;}	//gros indice = petit zoom (de loin)
  }
  
  
/////////////////////////////////////////////////////////////////
// rglage du zoom
/////////////////////////////////////////////////////////////////
  public void modifieZoom(int modif){
  	int horiz,vert;
  	Dimension tailleEcran = Toolkit.getDefaultToolkit().getScreenSize();
  	reduction = reduction + modif;
    if (reduction<1) {reduction=1;}    //petit indice = grand zoom (de prs)
  	if (reduction>5) {reduction=5;}	//gros indice = forte rduction (de loin)
  	if ((HORIZTOT/reduction+decalage)>(tailleEcran.width))//(Dimension) getSize()).width) 
  		{horiz = tailleEcran.width;}//((Dimension) getSize()).width;}
  		else {horiz = HORIZTOT/reduction+decalage;}
  	if ((VERTTOT/reduction+decalage)>(tailleEcran.height))//(Dimension) getSize()).height) 
  		{vert = tailleEcran.height;}//((Dimension) getSize()).height;}
  		else {vert = VERTTOT/reduction+decalage;}  		
  	repositionneSurActif();
    MAX_HORIZ = this.getWidth()-decalage;//((Dimension) getSize()).width; 
    MAX_VERT = this.getHeight()-decalage;//((Dimension) getSize()).height;
    this.getGraphics().clearRect(decalage, decalage, decalage+MAX_HORIZ, decalage+MAX_VERT);
    this.paint(this.getGraphics());
  }
  
/////////////////////////////////////////////////////////////////
// gestion du scrolling
/////////////////////////////////////////////////////////////////
  public void scrollhaut(){
      if ((VERTTOT/reduction)>MAX_VERT){
  	posycourrante = posycourrante - taillecase;
  	if (posycourrante < 0) {posycourrante=0;}
      }
  }

  public void scrollbas(){
     if ((VERTTOT/reduction)>MAX_VERT){
  	posycourrante = posycourrante + taillecase;
  	 if (posycourrante>(VERTTOT-MAX_VERT*reduction)) 
  	 {posycourrante=VERTTOT-MAX_VERT*reduction;}
     }
  }
  
  public void scrolldroite(){
     if ((HORIZTOT/reduction)>MAX_HORIZ){  	
	 posxcourrante = posxcourrante + taillecase;
  	 if (posxcourrante>(HORIZTOT-MAX_HORIZ*reduction)) 
  	 {posxcourrante=HORIZTOT-MAX_HORIZ*reduction;}
     }
  }
  
  public void scrollgauche(){
     if ((HORIZTOT/reduction)>MAX_HORIZ){
  	posxcourrante = posxcourrante - taillecase;
  	if (posxcourrante < 0) {posxcourrante=0;}
     }
  }
 
/////////////////////////////////////////////////////////////////  
// permet de positionner le centre de l'cran sur l'individu slectionn 
// ou le point cliqu avec le bouton droit de la souris :)
// ou encore l on on a cliqu sur la minicarte
/////////////////////////////////////////////////////////////////
 
  public void repositionneClic(int recupposx, int recupposy){
  	int posx, posy;
  	posx = convertiX(recupposx);
  	posy = convertiY(recupposy);  
  if ((VERTTOT/reduction)>MAX_VERT){
  	
  	if (((reduction*MAX_HORIZ/2+posxcourrante)-posx)>0)
  		{ if (posxcourrante<((reduction*MAX_HORIZ/2+posxcourrante)-posx)) 
  			{posxcourrante = 0;}  // on est trop prs du bord gauche pour aller plus loin
  			else {posxcourrante = posxcourrante - ((reduction*MAX_HORIZ/2+posxcourrante)-posx);}
  		}                      
  	else 
  		{ if ((HORIZTOT-(posxcourrante+reduction*MAX_HORIZ))<(posx-(posxcourrante+reduction*MAX_HORIZ/2)))
  			{posxcourrante = HORIZTOT-MAX_HORIZ*reduction;}
  			else {posxcourrante = posxcourrante + posx - (reduction*MAX_HORIZ/2+posxcourrante);}
  		}

  	if (((reduction*MAX_VERT/2+posycourrante)-posy)>0)
  		{ if (posycourrante<((reduction*MAX_VERT/2+posycourrante)-posy)) 
  			{posycourrante = 0;}  // on est trop prs du bord haut pour aller plus loin
  			else {posycourrante = posycourrante - ((reduction*MAX_VERT/2+posycourrante)-posy);}
  		}                      
  	else 
  		{ if ((VERTTOT-(posycourrante+reduction*MAX_VERT))<(posy-(posycourrante+reduction*MAX_VERT/2)))
  			{posycourrante = VERTTOT-MAX_VERT*reduction;}
  			else {posycourrante = posycourrante + posy - (reduction*MAX_VERT/2+posycourrante);}
  		}
  	
  	}
  this.getGraphics().clearRect(decalage, decalage, decalage+MAX_HORIZ, decalage+MAX_VERT);
  }
  
  
  public void repositionneSelection(int posx, int posy){
  	if ((VERTTOT/reduction)>MAX_VERT){
  		
  	if (posx<(reduction*MAX_HORIZ/2)) 
  		{ posxcourrante=0 ;}    // on est trop prs du bord gauche pour aller plus loin
  	else if (posx>(HORIZTOT-reduction*MAX_HORIZ/2))
  		{ posxcourrante= (HORIZTOT-reduction*MAX_HORIZ);}   // on est trop prs du bord droit pour aller plus loin
  	else posxcourrante = (posx-reduction*MAX_HORIZ/2); 
  	
  	if (posy<(reduction*MAX_VERT/2)) 
  		{ posycourrante=0 ;}    // on est trop prs du bord haut pour aller plus loin
  	else if (posy>(VERTTOT-reduction*MAX_VERT/2))
  		{ posycourrante= (VERTTOT-reduction*MAX_VERT);}   // on est trop prs du bord bas pour aller plus loin
  	else posycourrante = (posy-reduction*MAX_VERT/2); 
  	
  	}
	this.getGraphics().clearRect(decalage, decalage, decalage+MAX_HORIZ, decalage+MAX_VERT);
  }
  
  
  public void repositionneMiniCarte(int posx, int posy){
  	int xEcran, yEcran;
  	xEcran = posx*HORIZTOT/decalage;
  	yEcran = (posy-20)*VERTTOT/(decalage-20);
  	repositionneSelection(xEcran,yEcran);
  }
  
  
  public void repositionneSurActif(){
  	int posx = pere.donnePosXIndiv(qui);
  	int posy = pere.donnePosYIndiv(qui);
  	if ((VERTTOT/reduction)>MAX_VERT){
  		
  	if (posx<(reduction*MAX_HORIZ/2)) 
  		{ posxcourrante=0 ;}    // on est trop prs du bord gauche pour aller plus loin
  	else if (posx>(HORIZTOT-reduction*MAX_HORIZ/2))
  		{ posxcourrante= (HORIZTOT-reduction*MAX_HORIZ);}   // on est trop prs du bord droit pour aller plus loin
  	else posxcourrante = (posx-reduction*MAX_HORIZ/2); 
  	
  	if (posy<(reduction*MAX_VERT/2)) 
  		{ posycourrante=0 ;}    // on est trop prs du bord haut pour aller plus loin
  	else if (posy>(VERTTOT-reduction*MAX_VERT/2))
  		{ posycourrante= (VERTTOT-reduction*MAX_VERT);}   // on est trop prs du bord bas pour aller plus loin
  	else posycourrante = (posy-reduction*MAX_VERT/2); 
  	}
	this.getGraphics().clearRect(decalage, decalage, decalage+MAX_HORIZ, decalage+MAX_VERT);
  }

/////////////////////////////////////////////////////////////////
// conversion de coordonnes sur l'cran en coord absolue
/////////////////////////////////////////////////////////////////
  
  public int convertiX(int posxecran){
  	if(posxecran<decalage) {return 0;}
  	else if(posxecran>(HORIZTOT/reduction+decalage)) {return HORIZTOT;}
  	else {return ((posxecran-decalage)*reduction+posxcourrante);}
  }
  
  public int convertiY(int posyecran){
  	if(posyecran<decalage) {return 0;}
  	else if(posyecran>(VERTTOT/reduction+decalage)) {return VERTTOT;}
  	else {return ((posyecran-decalage)*reduction+posycourrante);}
  }
  
/////////////////////////////////////////////////////////////////
// affichage de la slection
/////////////////////////////////////////////////////////////////
  public void prepareSelection(int taille,int act){
  	int i;
  	selection1="";
  	selection2="";
  	actif="";
  	
  	for (i=1;i<act;i++){
  		selection1=selection1+" "+i+" ";
  	}
  	for (i=(act+1);i<=taille;i++){
  		selection2=selection2+" "+i+" ";
  	}
  	actif = " "+act+" ";
  }
  
  
  public void afficheSelection(Graphics g) {
      String help = "pour l'aide appuyer sur h";
    g.setFont(courierFont);
    
    // centre la slection
    FontMetrics m = g.getFontMetrics();
    int largeurTexte1 = m.stringWidth(selection1);
    int largeurTexte2 = m.stringWidth(actif);
    int largeurTexte3 = m.stringWidth(selection2);
    int positionTexteHoriz = ((MAX_HORIZ-largeurTexte1-largeurTexte2-largeurTexte3)/2);
    int positionTexteVert = (20+decalage/2);

    // dessine la selection
    g.setColor(Color.blue);
    g.drawString(selection1,positionTexteHoriz,positionTexteVert);
    g.setColor(Color.red);
    g.drawString(actif,positionTexteHoriz+largeurTexte1,positionTexteVert-10);
    g.setColor(Color.blue);
    g.drawString(selection2,positionTexteHoriz+largeurTexte1+largeurTexte2,positionTexteVert-10);
    g.setFont(smallfont);
    g.drawString(help,decalage+20,positionTexteVert+20);
    }
    
  public void selectionne(int act){
  	qui = act;  	
  }

/////////////////////////////////////////////////////////////////
// affichage des scores
/////////////////////////////////////////////////////////////////

  public void afficheScore(Graphics g) {
  	int i;
  	String temp;
  	scoresJoueurs = pere.donneScore();
  	g.setFont(medfont);
  	g.setColor(Color.blue);
  	for (i=0;i<scoresJoueurs.size();i++){
  	  temp = ((Data) scoresJoueurs.elementAt(i)).getNom();
  	  g.drawString(temp,10,80+40*(i+1));	
  	  temp = " "+((Data) scoresJoueurs.elementAt(i)).getIdentite();
  	  g.drawString(temp,10,100+40*(i+1));
  	}
  }

/////////////////////////////////////////////////////////////////
// bidules et autre trucs de la classe JFrame  implementer
/////////////////////////////////////////////////////////////////
    public void windowClosing(WindowEvent e) {
		pere.stoppeClient();
		marche=false;
		dispose();
    }
    
    public void windowClosed(WindowEvent e) {    }
    public void windowOpened(WindowEvent e) {    }
    public void windowIconified(WindowEvent e) {    }
    public void windowDeiconified(WindowEvent e) {    }
    public void windowActivated(WindowEvent e) {    }
    public void windowDeactivated(WindowEvent e) {    }
    public void windowGainedFocus(WindowEvent e) {    }
    public void windowLostFocus(WindowEvent e) {    }
    public void windowStateChanged(WindowEvent e) {    }
}
