package client;

import serveur.VecteurSerie;

public class GestionnaireImages {

  private VecteurSerie donnees = new VecteurSerie(); // le vecteur de string et d'int dcrivant les images
  private VecteurSerie images = new VecteurSerie() ; // le vecteur d'images correspondant
  static private int horiz, vert;   // taille de la fentre
  private String nomdimage; // string pour rcuprer le nom du gif  stocker
  private double positionx;    // position horizontale du gif
  private double positiony;    // position verticale du gif
  private Fantome acteur;   // images fantme des acteurs du jeux
  private int compteur;     // un compteur
  private Client pere;      // pour savoir avec qui interagir
  private GestionnaireFenetre fenetre;   //o se fait l'affichage
  private Data donneestemp;
  private String ambianceGraphique;


/////////////////////////////////////////////////////////////////
// constructeur
/////////////////////////////////////////////////////////////////
    public GestionnaireImages(int horizontal,int vertical,VecteurSerie donn, String ambiance, GestionnaireFenetre fen, Client cli) 
  	{
    horiz = horizontal;
    vert = vertical;
    donnees = donn;   
    ambianceGraphique=ambiance;
    fenetre = fen;
    pere = cli;
    convertiDonnees();

	}
	

/////////////////////////////////////////////////////////////////
// mise  jour des donnes
/////////////////////////////////////////////////////////////////

    public void remiseAJour(VecteurSerie donn){
		donnees=donn;
		fenetre.effaceIndividus();
		convertiDonnees();
    }

	public void modifsNom(VecteurSerie donn){
		donnees=donn;
		for(int i = 0; i < donnees.size(); i++){
			nomdimage = ambianceGraphique + ((Data)donnees.elementAt(i)).getNom() + ".gif";
			((Fantome)fenetre.individus.elementAt(i)).changeNom(nomdimage);
		}
	}

/////////////////////////////////////////////////////////////////
// convertit les donnes en images et les renvoit  l'affichage
/////////////////////////////////////////////////////////////////

  public void convertiDonnees() {
      for (compteur=0 ; compteur < donnees.size() ; compteur++)
  		{
		    try {
			donneestemp = (Data)(((Data)(donnees.elementAt(compteur)))/*.clone()*/);
    		} catch (IndexOutOfBoundsException outof) {
            System.err.println("IndexOutOfBoundsException" + outof);
        	}
		    
		    int numero = pere.getNumeroJoueur()+1;
			nomdimage = ambianceGraphique + donneestemp.getNom() + ".gif";
		    positionx = donneestemp.getPosx();
		    positiony = donneestemp.getPosy(); 
	
	   	acteur = new Fantome(nomdimage, positionx, positiony, fenetre);
  		fenetre.construitIndividus((Fantome)(acteur/*.clone()*/));
	    }
  }
  
/////////////////////////////////////////////////////////////////
// utilise les donnes pour mettre  jour l'affichage
/////////////////////////////////////////////////////////////////
  
  public void metAJour(VecteurSerie donn) {
  	for (compteur=0 ; compteur < donn.size() ; compteur++)
  		{
  		  try {
			donneestemp = (Data)(((Data)donn.elementAt(compteur)));
    		} catch (IndexOutOfBoundsException outof) {
            System.err.println("IndexOutOfBoundsException :" + outof);
        	}
        	
		// tests pour grer le scrolling
     	positionx = donneestemp.getPosx();
     	positiony = donneestemp.getPosy();
     	fenetre.metAJour(compteur,positionx,positiony);
  		}
  }
  
  
}
 
 
 
