package serveur;

import java.awt.*; 
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import serveur.*;
import client.*;
import serveur.PanelImageMouvante;



class PanneauBoutonsAmbiance extends JPanel implements ActionListener {
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    FenetreEntree pere;

    JLabel ambiance=new JLabel("Ambiance du jeu ?",JLabel.CENTER);

    public void actionPerformed(ActionEvent e) {
	pere.ambianceGraphique=e.getActionCommand();
    }
    public PanneauBoutonsAmbiance (FenetreEntree papa) {
	pere=papa;

	JRadioButton terreBouton = new JRadioButton("Terrestre");
	terreBouton.setMnemonic(KeyEvent.VK_T);
	terreBouton.setActionCommand("Terrestre/");
	terreBouton.setSelected(true);
	
	JRadioButton eauBouton = new JRadioButton("Aquatique");
	eauBouton.setMnemonic(KeyEvent.VK_A);
	eauBouton.setActionCommand("Aquatique/");
	
	ButtonGroup groupe = new ButtonGroup();
	groupe.add(terreBouton);
	groupe.add(eauBouton);

	terreBouton.addActionListener(this);
	eauBouton.addActionListener(this);
	
	Border raisedbevel = BorderFactory.createRaisedBevelBorder();
	Border loweredbevel = BorderFactory.createLoweredBevelBorder();
	setLayout(gridbag);
	c.fill = GridBagConstraints.BOTH;
	setBorder(BorderFactory.createCompoundBorder(raisedbevel, loweredbevel));
	
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(ambiance,c);
	add(ambiance);
	
	c.gridwidth = GridBagConstraints.RELATIVE;
	terreBouton.setPreferredSize(new Dimension(200, 50));
	gridbag.setConstraints(terreBouton,c);
	add (terreBouton);
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(eauBouton,c);
	add(eauBouton);
	
	setVisible(true);
    }
    
}


public class FenetreEntree extends JFrame implements ItemListener{
    

    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    JLabel legende1=new JLabel("Nom du serveur");
    JTextField ordiNom=new JTextField("localhost", 15);
    JLabel legende2=new JLabel("Nom de joueur");
    JTextField clientNom=new JTextField("moi", 15);
    JButton boutonAccord=new JButton("OK");
    JCheckBox boiteServeur=new JCheckBox("Creer le serveur ?"); 
    Client netClient;
    ConfigPanneau confPan = new ConfigPanneau();
    boolean panneauCree=false;
    private Image titre;
    private Image dessin;
    private String nomImageFond;
    private String nomImageFront;
    private PanelImageMouvante icone; 
    private PanneauBoutonsAmbiance panneauAmbiance = new PanneauBoutonsAmbiance(this);
    String ambianceGraphique="Terrestre/";


    class ActionAccord implements ActionListener {
        public synchronized void actionPerformed(ActionEvent e) 
        {lanceJeu();}
    };

   
    /**********************************************************************
     *Lance le jeu, avec le client et le serveur le cas chant
     *********************************************************************/

    void lanceJeu() {
	String nomServ=ordiNom.getText();
	String nomCli=clientNom.getText();
	if (boiteServeur.isSelected()==true) {
	    Maitre netServeur= new Maitre(this);
	    netServeur.getServeur().obtientNbVivants(confPan.nbMoutons.getText(), confPan.nbChiens.getText(), confPan.nbLoups.getText(), confPan.nbObstacles.getText());
	    netServeur.getServeur().init();
	    netClient=new Client();
	    hide();
	    netClient.main(nomServ, nomCli, !boiteServeur.isSelected(), ambianceGraphique, this);
	}
	else {
	    netClient=new Client();
	    hide();
	    netClient.main(nomServ, nomCli, !boiteServeur.isSelected(), ambianceGraphique, this);
	
	}
	
    }


    /***********************************************************************
     *Affiche ou cache la fentre de configuration
     **********************************************************************/
 
    public synchronized void itemStateChanged(ItemEvent e) {
	if (e.getStateChange() == ItemEvent.SELECTED) {
	    if (panneauCree==false) {
		gridbag.setConstraints(confPan,c);
		getContentPane().add (confPan);
		panneauCree=true;
		pack();
	    }
	    else {
	    gridbag.setConstraints(confPan,c);
		getContentPane().add(confPan);
		validate();
		pack();
	    }
	}
	else {
	    remove(confPan);
	    pack();
	}
    }


    public void  fermeJeu () {
	    System.exit(0);
    }

    /*******************************************************
     *Constructeur
     ******************************************************/

    public FenetreEntree() {
	super ("CroqueMouton 1.0"); 
	getContentPane().setLayout(gridbag);
	c.fill = GridBagConstraints.BOTH;
	Dimension tailleEcran = Toolkit.getDefaultToolkit().getScreenSize();

	nomImageFond="sprites/titre.gif";
	nomImageFront="sprites/mouton.gif";
	titre = Toolkit.getDefaultToolkit().createImage(nomImageFond);
	dessin = Toolkit.getDefaultToolkit().createImage(nomImageFront);

	icone = new PanelImageMouvante(titre, dessin); 
	icone.start();

	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(icone,c);
	getContentPane().add (icone);
	icone.setSize(525,100);

	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(boiteServeur,c);
	getContentPane().add (boiteServeur);
	boiteServeur.addItemListener(this);

	c.gridwidth = GridBagConstraints.RELATIVE;
	legende1.setPreferredSize(new Dimension(200, 50));
	gridbag.setConstraints(legende1,c);
	getContentPane().add (legende1);
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(ordiNom,c);
	getContentPane().add(ordiNom);

	c.gridwidth = GridBagConstraints.RELATIVE;
	legende2.setPreferredSize(new Dimension(200, 50));
	gridbag.setConstraints(legende2,c);
	getContentPane().add (legende2);
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(clientNom,c);
	getContentPane().add(clientNom);


	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(panneauAmbiance,c);
	getContentPane().add(panneauAmbiance);

	c.weightx = 0.0;
	gridbag.setConstraints(boutonAccord,c);
	getContentPane().add(boutonAccord);
	boutonAccord.addActionListener(new ActionAccord());
	setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	//	setLocation(450,200);
	setLocation(tailleEcran.width/2-300,tailleEcran.height/2-300);

	pack(); 
	setVisible(true);
    }
}
