package serveur;
import java.awt.*; 
import javax.swing.*;

class PanelImageMouvante extends Canvas implements Runnable{
    Image imageDerriere;
    Image imageDevant;
    int x=0;
    Thread animateur;
    int delais=40;

    Dimension offDimension;
    Image offImage;
    Graphics offGraphics;


    public PanelImageMouvante (Image imageFond, Image imageFront) {
	imageDerriere = imageFond;
	imageDevant = imageFront;
    }
    
    public void paint (Graphics g) {
	super.paint (g);
	g.drawImage(imageDerriere,0,0,this);
	g.drawImage(imageDevant,x,61,this);
    }
    public void start() {
	animateur = new Thread(this);
	animateur.start();
    }

    public void run() {
	// Remember the starting time
	long tm = System.currentTimeMillis();
	while (Thread.currentThread() == animateur) {
	    // Display the next frame of animation.
	    repaint();

	    // Delay depending on how far we are behind.
	    try {
		tm += delais;
		Thread.sleep(Math.max(0, tm - System.currentTimeMillis()));
	    } catch (InterruptedException e) {
		break;
	    }

	    // Advance the frame
	    if (x>525) {x=-10;}
	    x++;
	}
    }

  public void stop() {
	animateur = null;
	offImage = null;
	offGraphics = null;
    }

public void update(Graphics g) {
	Dimension d = getSize();

	// Create the offscreen graphics context
	if ((offGraphics == null)
	 || (d.width != offDimension.width)
	 || (d.height != offDimension.height)) {
	    offDimension = d;
	    offImage = createImage(d.width, d.height);
	    offGraphics = offImage.getGraphics();
	}

	// Erase the previous image
	offGraphics.setColor(getBackground());
	//	offGraphics.fillRect(0, 0, d.width, d.height);
	//offGraphics.setColor(Color.black);

	// Paint the frame into the image
	paint(offGraphics);

	// Paint the image onto the screen
	g.drawImage(offImage, 0, 0, null);
    }

  

}

