package serveur.individus.vivant;

import serveur.ServeurImpl;
import serveur.individus.*;
import serveur.VecteurSerie;
import client.Data;

abstract public class Controlable extends Vivant {
	
	protected int cibleX;
	protected int cibleY;
	protected VecteurSerie chemin = new VecteurSerie();
	protected boolean enRoute = false;
	
///////////////////////////////////////////////////////
//	Interface exterieur
///////////////////////////////////////////////////////
	public int donneCibleX(){return cibleX;}
	public int donneCibleY(){return cibleY;}	
	public boolean donneEtat(){return enRoute;}

///////////////////////////////////////////////////////
//	Gestion des cibles et des chemins
///////////////////////////////////////////////////////

	public void regleCible(int ciblehoriz, int ciblevert){
		enRoute = true;
		cibleX = ciblehoriz;
		cibleY = ciblevert;
		chemin.clear(); // le clic simple annule les chemins
		dirige();
	}

	public void arrive(){
		enRoute = false;
	}
	
	public void rajoutePointDeRoute(int ciblehoriz, int ciblevert){
		if (chemin.isEmpty()) regleCible(ciblehoriz,ciblevert);
		chemin.add(new Data((double) ciblehoriz,(double) ciblevert));
	}
	
	public void pointDeRouteSuivant(){
		if (!(chemin.isEmpty())) 
		{   // il y a un chemin en cours
			chemin.removeElementAt(0);  //on passe  la suite
			if (!(chemin.isEmpty()))    //s'il en reste
			{
				cibleX = (int)(((Data)chemin.elementAt(0)).getPosx());
				cibleY = (int)(((Data)chemin.elementAt(0)).getPosy());
				dirige();				
			}
			else arrive();   //sinon on s'arrete de chercher
		}
		else arrive(); //s'il n'y a pas de chemin 
											  //c'est qu'on avait qu'un point de route, 
											  // et on regarde si on est arriv ou non. 
	}
	
	public boolean testDeProximite(){
		return (((posHoriz-cibleX)*(posHoriz-cibleX)+(posVert-cibleY)*(posVert-cibleY))<2*(rayon+vitesseMax));
	}
	
	
///////////////////////////////////////////////////////
//	Mise  jour des indicateurs de dplacement
///////////////////////////////////////////////////////
	
	public void dirige(){
		indicateurHoriz = cibleX - posHoriz;
		indicateurVert = cibleY - posVert;
		if (testDeProximite()) pointDeRouteSuivant();		
	}
	
///////////////////////////////////////////////////////
//	Surcharge de Maz pour ne pas que les indicateurs
// se remettent  zro tant que l'individu  une mission
///////////////////////////////////////////////////////	
	
	  public void action (){
  	    double module;

		MaZ();
		if(enRoute){dirige();}

		monServeur.ouSuisJe(this);
		modifIndic();
		
		seDeplacer();
		       	
       	reaction();

  	}

	public Controlable(ServeurImpl serv){
		super(serv);
	}

}