package serveur.individus.vivant;

import serveur.ServeurImpl;
import serveur.individus.*;

abstract public class Vivant extends Individus {
  /** Attributes */
  protected double indicateurHoriz;
  protected double indicateurVert;
  protected double vitesseMax;

	// On peut les retirer et utiliser directement les constantes
	// Faut s'occuper de MAX_HORIZ et MAX_VERT avant.
  protected int bloqueHorizGauche = 0;
  protected int bloqueHorizDroite; //MAX_HORIZ;
  protected int bloqueVertHaut    = 0;
  protected int bloqueVertBas; //MAX_VERT;  tendu mais toujours  changer
  
  protected int pointsDeVie = 0;

	// N'importe quel etre vivant peut attaquer, 
	// d'aprs la remarque d'Aurlien:
	// Si tout plein de dauphins se mettent enesemble,
	// il peuvent avoir un requin

///////////////////////////////////////////////////////
//	Interface exterieur
///////////////////////////////////////////////////////
	public double getVitesse(){return vitesseMax;}
	public void definirPointsDeVie(int nombrePointsDeVie){pointsDeVie = nombrePointsDeVie;}

    public void mourir() {
		definirNom(recupererNom()+"mort");
		actif = false;
		monServeur.declencheMiseAJour();
    }

    public void attaquer(Individus tueur) {
   		double dist = distance (tueur.recupererPosHoriz(), tueur.recupererPosVert(), posHoriz, posVert), indic;
		if(dist < (tueur.recupererRayon()+2*this.recupererRayon())){
			pointsDeVie--;
			if(pointsDeVie < 0){mourir();}
		}
    }

		
///////////////////////////////////////////////////////
//	Ractions de base qd prend connaissance du monde
///////////////////////////////////////////////////////
  public void voirIndividu ( double x, double y, ComportementIndividu action, int numIndiv, boolean activite)
  		// indic est positif si il faut partir
  		// en temps normal s'eloigne de tout ce qui est plus dangereux
  		// qd on surcharge penser a 'repulsivite' qui est retranche
  {
  	  	
	Individus autre = ((Individus)(monServeur.occupants.elementAt(numIndiv)));
	double dist = distance (x, y, posHoriz, posVert), indic;
	double distmin = rayon + autre.recupererRayon();
	
  	if(dist > 0){

		// Pour pas aller n'importe ou... (ne pas se chevaucher)		 		
  		if((dist < distmin) && !action.recupererPassage()){
  			indic = (dist - distmin) * 1000;
  		}else{
  			indic = 0;
  		}

		// Si l'autre individu est actif (ni mort, ni sauve...)
		if(activite){
			// va vers lui ou le fuit selon le comportement que le serveur lui dicte
  			indic=indic+action.recupererAttirance();
	
			// C'est la qu'on gre les actions des individus vivants...
			if (action.recupererAction()=="attaquer"){
				((Vivant)(monServeur.occupants.elementAt(numIndiv))).attaquer(this);
			}	

		}	
	
  		indicateurHoriz = indicateurHoriz - indic * (posHoriz - x) / dist;
		indicateurVert  = indicateurVert  - indic * (posVert  - y) / dist;

	}
	
  };

///////////////////////////////////////////////////////
//	Action : une tape dans le tour de jeu.
///////////////////////////////////////////////////////
	// Tour de jeu
  public void action (){
		MaZ();
		monServeur.ouSuisJe(this);
		modifIndic();
		seDeplacer();
       	reaction();
  	}

	// Mise a zero des indicateurs de deplacement
	void MaZ(){
		indicateurVert = 0;
		indicateurHoriz= 0;
	};
	// Si un animal a envie de les remodifier apres (genre le loup pour errer)
	void modifIndic(){
		indicateurHoriz = indicateurHoriz + (Math.random()-0.5);
		indicateurVert  = indicateurVert  + (Math.random()-0.5);
	};  	
	// L'action finale d'un animal apres avoir scrut l'environnement
	void reaction(){
	};
  	// Le dplacement rel
  	public void seDeplacer(){
  	    double module;
  				// Blocage si part n'importe ou.
	  	if(indicateurHoriz > 0 && (bloqueHorizDroite - posHoriz) <= (rayon + vitesseMax)){
	  		indicateurHoriz = -0.001;
	  	}
	  	if(indicateurHoriz < 0 && (posHoriz - bloqueHorizGauche) <= (rayon + vitesseMax)){
	  		indicateurHoriz = +0.001;
	  	}
	  	if(indicateurVert  > 0 && (bloqueVertBas - posVert)      <= (rayon + vitesseMax)){
	  		indicateurVert  = -0.001;
	  	}
	  	if(indicateurVert  < 0 && (posVert - bloqueVertHaut)     <= (rayon + vitesseMax)){
	  		indicateurVert  = +0.001;
	  	}

    	// dplacement ramen  un module de 'vitesseMax'
    	module = distance (0.0, 0.0, indicateurHoriz, indicateurVert);
       	posHoriz = posHoriz + ((vitesseMax)*(indicateurHoriz))/module;
       	posVert  = posVert  + ((vitesseMax)*(indicateurVert ))/module;

  	}


	// Fonction de base
	public double distance (double x1, double y1, double x2, double y2){
		return Math.sqrt(Math.pow(x1 - x2, 2.0) + Math.pow(y1 - y2, 2.0));
	}
	
	// Pour savoir avec quel serveur on travaille
	public Vivant(ServeurImpl serv){
		super(serv);
		bloqueHorizDroite = monServeur.tailleX - 2*rayon;
		bloqueVertBas = monServeur.tailleY - 2*rayon;
	}
  
}

